<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib uri="http://amateras.sf.jp/functions" prefix="f" %>
<%@ taglib uri="http://amateras.sf.jp/log4j" prefix="log4j" %>
<html>
  <head>
    <title>Java Standard EL Functions</title>
  </head>
  <body>
    <h2>HTMLエスケープ</h2>
    <form method="POST">
      <input type="text" name="name" value="${f:h(param['name'])}">
      <input type="submit" value="送信">
    </form>
    ${f:h(param['name'])}

    <h2>UTF-8でのURLエンコード</h2>
    <a href="http://www.google.co.jp/search?q=${f:u(param['name'])}">Googleで「${f:h(param['name'])}」を検索</a>

    <h2>改行変換</h2>
    <form method="POST">
      <textarea name="message">${f:h(param['message'])}</textarea>
      <input type="submit" value="送信">
    </form>
    ${f:br(f:h(param['message']))}

    <h2>日付のフォーマット</h2>
    <% pageContext.setAttribute("date", new java.util.Date()); %>
    <ul>
      <li>${f:date(date)}</li>
      <li>${f:datetime(date)}</li>
    </ul>

    <h2>数値のフォーマット</h2>
    <ul>
      <li>${f:number(1, '000')}</li>
      <li>${f:number(9999999, '#,###')}</li>
    </ul>

    <h2>文字列のカット</h2>
    ${f:cut('あいうえお', 3)}

    <h2>URLをリンクに変換</h2>
    ${f:link('Google(http://www.google.co.jp)で検索')}

    <h2>クエリ文字列を作成</h2>
    <%
      java.util.Map<String, String> map = new java.util.HashMap<String, String>();
      map.put("q", "Javaライブラリ徹底活用");
      map.put("hl", "ja");
      pageContext.setAttribute("map", map);
    %>
    <a href="http://www.google.co.jp/search?${f:query(map)}">Googleで検索</a>

    <h2>文字列のテスト</h2>
    <p>
      <c:if test="${f:matches('takezoe@gmail.com', '.*@.*')}">
        "takezoe@gmail.com" はメールアドレスの形式です。
      </c:if>
    </p>
    <p>
      <c:if test="${f:contains('JavaScript', 'Java')}">
        "JavaScript" に "Java"は含まれています。
      </c:if>
    </p>
    <p>
      <% pageContext.setAttribute("array", new String[]{"Ruby", "Python", "Java"}); %>
      <c:if test="${f:contains(array, 'Java')}">
        {"Ruby", "Python", "Java"} に "Java"は含まれています。
      </c:if>
    </p>

    <h2>ログ出力関数</h2>
    <p>
      ${log4j:debug('デバッグログです。')}
    </p>
    <p>
      ${log4j:printDebug('デバッグログが有効な場合のみ表示されます。')}
    </p>
    <c:if test="${log4j:isDebugEnabled()}">
      <p>
        デバッグログが有効な場合のみ表示されます。
      </p>
    </c:if>
  </body>
</html>
