package jp.sf.amateras.javalib.captcha;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class CaptchaServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {

		// 正解の値を取得
		HttpSession session = req.getSession();
		String expected = (String) session.getAttribute(
				com.google.code.kaptcha.Constants.KAPTCHA_SESSION_KEY);

		// ユーザからの入力値を取得
		String answer = req.getParameter("answer");

		// 入力値が正しいかどうかをチェック
		if (answer != null && answer.equals(expected)) {
			// 正しい
			req.setAttribute("result", "success");
		} else {
			// 正しくない
			req.setAttribute("result", "failure");
		}

		// JSPにフォワード
		ServletContext context = getServletContext();
		RequestDispatcher dispatcher = context.getRequestDispatcher("/captcha.jsp");
		dispatcher.forward(req, resp);
	}

}
