package jp.sf.amateras.javalib.fileupload;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.io.IOUtils;

public class FileUploadServlet extends HttpServlet {

	  private static final long serialVersionUID = 1L;

	  @Override
	  protected void doPost(HttpServletRequest request, HttpServletResponse response)
	      throws ServletException, IOException {
	    // マルチパートリクエストかどうかをチェック
	    if(ServletFileUpload.isMultipartContent(request)){
	      try {
	        DiskFileItemFactory factory = new DiskFileItemFactory();
	        factory.setSizeThreshold(1024);
	        factory.setRepository(new File("C:/tmp"));

	        ServletFileUpload upload = new ServletFileUpload(factory);
	        //upload.setFileSizeMax(1024);

	        @SuppressWarnings("unchecked")
	        List<FileItem> items = upload.parseRequest(request);

	        for(FileItem item: items){
	          String fieldName = item.getFieldName();

	          if(fieldName.equals("uploadFile")){
	            // ファイルフィールドの場合
	            String fileName = item.getName();
	            request.setAttribute("fileName", fileName);

	            // ファイルを保存
	            InputStream in = item.getInputStream();
	            FileOutputStream out = new FileOutputStream("C:/tmp/" + fileName);

	            IOUtils.copy(in, out);
	            IOUtils.closeQuietly(in);
	            IOUtils.closeQuietly(out);

	          } else if(fieldName.equals("comment")){
	            // ファイル以外のフィールドの場合
	            String comment = item.getString("UTF-8");
	            request.setAttribute("comment", comment);
	          }
	        }
	      } catch(FileUploadException ex){
	        throw new ServletException(ex);
	      }
	    }

	    // JSPにフォワード
	    ServletContext context = getServletContext();
	    RequestDispatcher dispatcher = context.getRequestDispatcher("/fileupload.jsp");
	    dispatcher.forward(request, response);
	  }

}
